import wblut.processing.*;
import wblut.geom.*;
import java.util.List;

import peasy.*;

PeasyCam cam;


List<WB_Point> points;
List<WB_VoronoiCell3D> voronoi;

WB_Render3D render;
WB_GeometryFactory gf=new WB_GeometryFactory();
WB_AABB box;

int[] blank;
color checkout_color;
float[] rectHeight;


int Y_AXIS = 1;
int X_AXIS = 2;


final float margin_left = 180;
final float margin_top = 70;



float cell_width, cell_height;

int[] months;
int[] months2;
int[] months3;
int[] months4;
int[] months5;

Table all_data; 
Table all_data2;
Table all_data3;
Table all_data4;
Table all_data5;

int  rows, cols;
int rows2, cols2;
int  rows3, cols3;
int rows4, cols4;
int rows5, cols5;

float[][] data_matrix; 
float[][] data_matrix2; 
float[][] data_matrix3; 
float[][] data_matrix4;
float[][] data_matrix5;

float max, min;

int numMonth = 12;
int numScale = 10;



color[] m={color(255, 0, 0), color(0, 255, 0), color(250, 255, 100), color(255, 100, 0), color(27, 0, 128)};
String [] Month = {"1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12"};
String [] Scale = {"100", "90", "80", "70", "60", "50", "40", "30", "20", "10", "0"};





void setup() {
  
  size(1000, 1000, P3D);
  smooth(8);
  render= new WB_Render3D(this);

  //peasy cam
  //cam = new PeasyCam(this, 700);

  cam = new PeasyCam(this, 700, 1000, 25, 1500);
  cam.setSuppressRollRotationMode();
  //PeasyCam HUD function doesnt work with the HE_MESH library i think
  //cam.beginHUD();
  //fill(255);
  //textSize(40);
  //text("Echo Theohar", 200,200);
  //cam.endHUD();

  //data
  all_data = loadTable("CapitalFinal.csv", "header");
  all_data2 = loadTable("LeviathanFinal.csv", "header");
  all_data3 = loadTable("RepublicFinal.csv", "header");
  all_data4 = loadTable("CommunistFinal.csv", "header");
  all_data5 = loadTable("RepublicFinal.csv", "header");

   rows = all_data.getRowCount ();
  cols = all_data.getColumnCount ();
  
  rows2 = all_data2.getRowCount ();
  cols2 = all_data2.getColumnCount ();
  
   rows3 = all_data3.getRowCount ();
  cols3 = all_data3.getColumnCount ();
  
    rows4 = all_data4.getRowCount ();
  cols4 = all_data4.getColumnCount ();
  
  rows5 = all_data5.getRowCount ();
  cols5 = all_data5.getColumnCount ();

  println("row " + rows);
  println("col " + cols);

   data_matrix = new float[rows][cols-1];
  months = new int[rows];
  
   data_matrix2 = new float[rows][cols2-1];
  months2 = new int[rows];
  
   data_matrix3 = new float[rows][cols3-1];
  months3 = new int[rows];
  
  data_matrix4 = new float[rows][cols4-1];
  months4 = new int[rows];
  
  data_matrix5 = new float[rows][cols5-1];
  months5 = new int[rows];
  
  ///////

  for (int i = 0; i < data_matrix.length; i++) {
    for (int j = 0; j < data_matrix[0].length; j++) {
      data_matrix[i][j] = log(all_data.getFloat(i, j)+1);
    }
  }

  //get max and min value from the array
  for (int i = 0; i < data_matrix.length; i++) {
    for (int j = 0; j < data_matrix[0].length; j++) {
      if (data_matrix[i][j] > max) {
        max = data_matrix[i][j];
      }
    }
  }
  
  ////////// END LAYER 1
  
   for (int a=0; a<data_matrix2.length; a++) {
    for (int b=0; b<data_matrix2[0].length; b++) {
      data_matrix2[a][b] = log(all_data2.getFloat(a, b)+1);
    }
  }
  //get max and min data from the array
  for (int a=0; a<data_matrix2.length; a++) {
    for (int b=0; b<data_matrix2[0].length; b++) {
      if (data_matrix2 [a][b] > max) { 
        max = data_matrix2[a][b];
      }
      }
    }
    
    /////////END LAYER 2
    
     for (int c=0; c<data_matrix3.length; c++) {
    for (int d=0; d<data_matrix3[0].length; d++) {
      data_matrix3[c][d] = log(all_data3.getFloat(c, d)+1);
    }
  }
  ////get max and min data from the array
  for (int c=0; c<data_matrix3.length; c++) {
    for (int d=0; d<data_matrix3[0].length; d++) {
      if (data_matrix3 [c][d] > max) { 
        max = data_matrix3[c][d];
      }
      }
    }
    
    //////END LAYER 3
    
    for (int e=0; e<data_matrix4.length; e++) {
    for (int f=0; f<data_matrix4[0].length; f++) {
      data_matrix4[e][f] = log(all_data4.getFloat(e, f)+1);
    }
  }
  ////get max and min data from the array
  for (int e=0; e<data_matrix4.length; e++) {
    for (int f=0; f<data_matrix4[0].length; f++) {
      if (data_matrix4 [e][f] > max) { 
        max = data_matrix4[e][f];
      }
      }
    }
    
    ///////END LAYER 4
    
      for (int e=0; e<data_matrix5.length; e++) {
    for (int f=0; f<data_matrix5[0].length; f++) {
      data_matrix5[e][f] = log(all_data5.getFloat(e, f)+1);
    }
  }
  ////get max and min data from the array
  for (int e=0; e<data_matrix5.length; e++) {
    for (int f=0; f<data_matrix5[0].length; f++) {
      if (data_matrix5 [e][f] > max) { 
        max = data_matrix5[e][f];
      }
      }
    }
    
    ///////END LAYER 5
  
  min = 0;
  cell_width = (width - margin_left * 2) / cols;
  cell_height = (height - margin_top * 2) / (rows + 2);

  println("width: " + cell_width);
  println("height: " + cell_height);

  //draw grid
  points=new ArrayList<WB_Point>();
  // add points to collection
  for (int i=0; i<12; i++) {
    for (int j=0; j<5; j++) {
      for (int k=0; k<5; k++) {
        pushMatrix();
        translate(200, -250, 200);
        points.add(new WB_Point(-200+i*80, -200+j*80, k*200));
        popMatrix();
      }
    }
  }




  //
  box=new WB_AABB(-250, -250, -250, 250, 250, 250);
  voronoi= WB_Voronoi.getVoronoi3D(points, box, 4);

  //textAlign(CENTER);
}

void draw() {
  background(0);
  
  //////LAYER 1

  for (int i=0; i<data_matrix.length; i++) {
    for (int j=0; j<data_matrix[0].length; j++) {
    //int multiplier = 2;
    checkout_color = (int) map(data_matrix[i][j], min, max, 255, 0);
    
  // ypos = margin_top + j*multiplier;
    fill(checkout_color);
    pushMatrix();
    translate(-100,860, 400);
    rotateX(radians(-28));
    rotateY(radians(-30));
    rotateZ(radians(270));
    rect(cell_width, i*80, data_matrix.length+40, 40);
    popMatrix();
 
  }
  }
  
  //////////// LAYER 2
  
   for (int i=0; i<data_matrix2.length; i++) {
    for (int j=0; j<data_matrix2[0].length; j++) {
    //int multiplier = 2;
    checkout_color = (int) map(data_matrix2[i][j], min, max, 255, 0);
  // ypos = margin_top + j*multiplier;
    fill(checkout_color);
    pushMatrix();
    translate(0,840, 200);
    rotateX(radians(-28));
    rotateY(radians(-30));
    rotateZ(radians(270));
    rect(cell_width, i*80, data_matrix2.length+40, 40);
    popMatrix();
 
  }
  }
  
  ////////// LAYER 3
  
   for (int i=0; i<data_matrix3.length; i++) {
    for (int j=0; j<data_matrix3[0].length; j++) {
    //int multiplier = 2;
    checkout_color = (int) map(data_matrix3[i][j], min, max, 255, 0);
  // ypos = margin_top + j*multiplier;
     fill(checkout_color);
    pushMatrix();
    translate(100,820, 0);
    rotateX(radians(-28));
    rotateY(radians(-30));
    rotateZ(radians(270));
    rect(cell_width, i*80, data_matrix3.length+40, 40);
    popMatrix();
  }
  }
  
  /////////// LAYER 4
  
   for (int i=0; i<data_matrix4.length; i++) {
    for (int j=0; j<data_matrix4[0].length; j++) {
    //int multiplier = 2;
    checkout_color = (int) map(data_matrix4[i][j], min, max, 255, 0);
  // ypos = margin_top + j*multiplier;
    fill(checkout_color);
    pushMatrix();
    translate(200,800, -200);
    rotateX(radians(-28));
    rotateY(radians(-30));
    rotateZ(radians(270));
    rect(cell_width, i*80, data_matrix4.length+40, 40);
    popMatrix();
  }
  }
  
 /////////// LAYER 5
  
   for (int i=0; i<data_matrix5.length; i++) {
    for (int j=0; j<data_matrix5[0].length; j++) {
    //int multiplier = 2;
    checkout_color = (int) map(data_matrix5[i][j], min, max, 255, 0);
  // ypos = margin_top + j*multiplier;
    fill(checkout_color);
    pushMatrix();
    translate(300,800, -400);
    rotateX(radians(-28));
    rotateY(radians(-30));
    rotateZ(radians(270));
    rect(cell_width, i*80, data_matrix4.length+40, 40);
    popMatrix();
  }
  }


  rotateX(-.5f);
  rotateY(-.5f);



  //draw grid
  translate(width/2, height/2);
  //stroke(0, 0, 255);
  //rotateY(mouseX*1.0f/width*TWO_PI);
  //rotateX(mouseY*1.0f/height*TWO_PI);
  noFill();
  strokeWeight(2);
  render.drawPoint(points, 1); 
  strokeWeight(.5);
  noFill();

  //draw 5 boxes

  for (int b=0; b<5; b++) {
    pushMatrix();
    translate(200, -0, 200*b);
    // fill (m[b], 50);
    stroke(255);
    noFill();
    box(1000, 400, 200);
    popMatrix();
  }

  // Draw month text Layer 1
  for (int i = 0; i < numMonth; i++) {
    fill(0, 255, 255);
    textSize(20);
    pushMatrix();
    translate(0, 0, 800);
    text(Month[i], .37*cell_width*i-200, 
      margin_top - 350 );
    popMatrix();
  }

  // Draw month text Layer 2
  for (int i = 0; i < numMonth; i++) {
    fill(255, 100, 0);
    textSize(20);
    pushMatrix();
    translate(0, 0, 600);
    text(Month[i], .37*cell_width*i-200, 
      margin_top - 350 );
    popMatrix();
  }

  // Draw month text Layer 3
  for (int i = 0; i < numMonth; i++) {
    fill(255, 255, 0);
    textSize(20);
    pushMatrix();
    translate(0, 0, 400);
    text(Month[i], .37*cell_width*i-200, 
      margin_top - 350 );
    popMatrix();
  }

  // Draw month text Layer 4
  for (int i = 0; i < numMonth; i++) {
    fill(0, 255, 0);
    textSize(20);
    pushMatrix();
    translate(0, 0, 200);
    text(Month[i], .37*cell_width*i-200, 
      margin_top - 350 );
    popMatrix();
  }

  // Draw month text Layer 5
  for (int i = 0; i < numMonth; i++) {
    fill(255, 0, 0);
    textSize(20);
    pushMatrix();
    translate(0, 0, 0);
    text(Month[i], .37*cell_width*i-200, 
      margin_top - 350 );
    popMatrix();
  }

  // Draw scale text Layer 1
 
  //for (int j = 0; j < numScale; j++) { 
    pushMatrix();
    textSize(20);
     fill(0, 255, 255);
    translate(0, 0, 800);
    //text(Scale[j], .37*cell_width-450, 
      //1.1*margin_top*j - 180 );
       textAlign(RIGHT);
      text("Capital", -350, -180);
    popMatrix();
 // }

  // Draw scale text Layer 2
  
 // for (int j = 0; j < numScale; j++) {
    pushMatrix();
    textSize(20);
    fill(255, 100, 0);
    translate(0, 0, 600);
    //line(-50,1.1*margin_top*j, 700,1.1*margin_top*j);
   // text(Scale[j], .37*cell_width-450, 
     // 1.1*margin_top*j - 180 );
      textAlign(RIGHT);
     text("Leviathan", -350, -100);
    popMatrix();
 // }

  // Draw scale text Layer 3
  
 // for (int j = 0; j < numScale; j++) {
    pushMatrix();
     fill(255, 255, 0);
    textSize(20);
    translate(0, 0, 400);
    //text(Scale[j], .37*cell_width-450, 
     // 1.1*margin_top*j - 180 );
      textAlign(RIGHT);
      text("Republic", -350, -30);
    popMatrix();
 // }


  // Draw scale text Layer 4
  
  //for (int j = 0; j < numScale; j++) {
    pushMatrix();
     fill(0, 255, 0);
    textSize(20);
    translate(0, 0, 200);
    //text(Scale[j], .37*cell_width-450, 
      //1.1*margin_top*j - 180 );
      textAlign(RIGHT);
      text("Communist Manifesto", -350, 50);
    popMatrix();
  //}

  // Draw scale text Layer 5
  
 // for (int j = 0; j < numScale; j++) {
    pushMatrix();
     fill(255, 0, 0);
    textSize(20);
    translate(0, 0, 0);
   // text(Scale[j], .37*cell_width-450, 
     // 1.1*margin_top*j - 180 );
     text("Theory of Justice",-350, 130);
    popMatrix();
 // }
}